/* clib/svobjects.h		    */
/* Version    : 4.1		    */
/* Date       : 15.05.1994	    */
/* Written by : Andreas R. Kleinert */

/* SVObject-Version V2.x+ */

#ifndef CLIB_SVOBJECTS_PROTOS_H
#define CLIB_SVOBJECTS_PROTOS_H

#ifndef SVOBJECTS_SVOBJECTS_H
#include <svobjects/svobjects.h>
#endif /* SVOBJECTS_SVOBJECTS_H */

APTR SVO_AllocHandle(       APTR future);
ULONG SVO_FreeHandle(       APTR handle);
ULONG SVO_Show(             APTR handle);
ULONG SVO_Write(            APTR handle);
ULONG SVO_CloseDisplay(     APTR handle);
ULONG SVO_FreeResources(    APTR handle);
ULONG SVO_SetAccessMode(    APTR handle,
			    ULONG mode);
ULONG SVO_SetWriteSubType(  APTR handle,
			    ULONG subtype,
			    APTR future);
ULONG SVO_SetScreenType(    APTR handle,
			    ULONG flags,
			    APTR future);
ULONG SVO_SetWindowFlags(   APTR handle,
			    ULONG flags,
			    APTR future);
ULONG SVO_SetWindowIDCMP(   APTR handle,
			    ULONG flags,
			    APTR future);
APTR  SVO_GetScreenAddress( APTR handle,
			    APTR future);
APTR  SVO_GetWindowAddress( APTR handle,
			    APTR future);
ULONG SVO_SetScreenAddress( APTR handle,
			    struct Screen *screen,
			    APTR future);
ULONG SVO_SetWindowAddress( APTR handle,
			    struct Window *window,
			    APTR future);
ULONG SVO_SetWriteName(     APTR handle,
			    UBYTE *filename,
			    APTR future);
ULONG SVO_SetReadName(      APTR handle,
			    UBYTE *filename,
			    APTR future);
ULONG SVO_FileInfoRequest(  APTR handle,
			    struct Window *window,
			    ULONG future);
ULONG SVO_CheckFileType(    BPTR filehandle,
			    UBYTE *filename,
                            struct SVOCheckFile *svo_check);

                            /* svo_check is supported since superview-library
                               V4 and is only initialized, when any medium
                               other than AKO_MEDIUM_DISK should be used for
                               reading. Ignoring it is allowed for V1 and V2
                               SVObjects for compatibility reasons.
                             */

/* added with V2 */
ULONG SVO_ReadToGfxBuffer(  APTR handle);
ULONG SVO_GetGfxBuffer(     APTR handle,
			    struct SV_GfxBuffer **bufferhandle,
			    ULONG future);
ULONG SVO_SetGfxBuffer(     APTR handle,
			    struct SV_GfxBuffer *bufferhandle,
			    ULONG future);

#endif /* CLIB_SVOBJECTS_PROTOS_H */
